<?php

namespace App\Controllers;

//use App\Models\JeKonkurisaoModel;
//use App\Models\KonkursModel;
//use App\Models\KorisnikModel;
//use App\Models\PravnoLiceModel;
use App\Models as M;

class Pretraga extends BaseController
{
    protected function prikaz($page, $data) {
        echo view("stranice/$page", $data);
    }
    
    public function index()
    {
        $this->prikaz("pretraga", []);
    }
    
    public function rezultati()
    {
        $ime = $this->request->getVar('konkursime');
        $praksa = $this->request->getVar('praksa')=='praksa'?1:0;
        $zaposlenje = $this->request->getVar('zaposlenje')=='zaposlenje'?1:0;
        
        if ($praksa || $zaposlenje) {
            $tip = $praksa?'p':'z';
        }
        else {$tip = 'o';}
               
        $konkursModel = new M\KonkursModel();
        if ($tip == 'o') $konkursi = $konkursModel->like('naziv', $ime)->findAll();
        else $konkursi = $konkursModel->like('naziv', $ime)->where('tip', $tip)->findAll();
        
        $data['konkursi'] = $konkursi;
        
        return $this->prikaz("rezultati", $data);
    }
    
    public function konkurisi()
    {
        $korime = $this->request->getVar('korisnickoime');
        $jekonkModel = new M\JeKonkurisaoModel();
        $korisnikModel = new M\KorisnikModel();
        $pravnoModel = new M\PravnoLiceModel();
        
        $konkurs = $this->request->getVar('konkurs');
        
        if ($korime == "") {
            $data['poruka']= "Morate uneti korisnicko ime";
        }
        else if (!$konkurs) {
            $data['poruka']= "Morate izabrati konkurs";
        }
        else {
            $pravno = $pravnoModel->find($korime);
            $kor = $korisnikModel->find($korime);
            if ($kor == null) {
                $data['poruka']= "Niste korisnik";
            }
            else if ($pravno != null){
                $konkursModel = new KonkursModel();
                if ($konkursModel->find($konkurs)->tip == 'z')
                    $data['poruka']= "Pravno ste lice i ne mozete konkurisati za zaposlenje";
                else {
                    $jekonkModel->save([
                        'konkurs_id' => $konkurs,
                        'korisnik' => $kor->korisnickoime,
                        'datum_aplikacije' => date("Y-m-d H:i:s")
                    ]);
                    $data['poruka']= "ok";
                }
            }
            else {
                
                $apl = $jekonkModel->where('korisnik', $korime)->where('konkurs_id', $konkurs)->findAll();
                if ($apl) {
                    $data['poruka']= "Vec ste konkurisali";
                }
                else {
                    $jekonkModel->save([
                        'konkurs_id' => $konkurs,
                        'korisnik' => $kor->korisnickoime,
                        'datum_aplikacije' => date("Y-m-d H:i:s")
                    ]);
                    $data['poruka']= "ok";
                }
            }
        }
        return $this->prikaz("rezultati", $data);
    }
}
